VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PhModiApiFactory"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private WebServiceContainer As WebServices.IWebServiceContainer
Public Function PhModiApi() As PhModiClientVb6.IPhModiApi

Set PhModiApi = WebServiceContainer

End Function
Public Function GetElementCount(matriu As Variant) As Integer

On Error Resume Next
GetElementCount = UBound(matriu) - LBound(matriu) + 1

End Function
Public Function GetElement(matriu As Variant, index As Integer) As Variant

On Error Resume Next
If IsObject(matriu(index)) Then
   Set GetElement = matriu(index)
Else
   GetElement = matriu(index)
End If

End Function
Public Function IsAvailable() As Boolean

IsAvailable = Not WebServiceContainer Is Nothing And TypeOf WebServiceContainer Is IPhModiApi

End Function
Public Function WebServiceProxi() As WebServices.IWebServiceProxi

If Not WebServiceContainer Is Nothing Then Set WebServiceProxi = WebServiceContainer.WebServiceProxi

End Function
Public Sub Initilize(ServiceFactory As WebServices.IWebServiceFactory, WebServiceName As String)

If Not ServiceFactory Is Nothing Then
    If ServiceFactory.IsAvailable Then
        Set WebServiceContainer = ServiceFactory.WebServiceContainer(WebServiceName)
        If Not TypeOf WebServiceContainer Is PhModiClientVb6.IPhModiApi Then Me.Terminate
    End If
End If

End Sub
Public Sub Terminate()

Class_Terminate

End Sub
Private Sub Class_Terminate()

If Not WebServiceContainer Is Nothing Then WebServiceContainer.WebServiceProxi.Terminate
Set WebServiceContainer = Nothing

End Sub
