VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoapErrorTypeMapper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements MSSOAPLib30.ISoapTypeMapper

Private m_Factory As MSSOAPLib30.ISoapTypeMapperFactory
Private m_Schema As MSXML2.IXMLDOMNode
Private m_WSMLNode As MSXML2.IXMLDOMNode
Private m_xsdType As MSSOAPLib30.enXSDType
Private Sub Class_Initialize()

'sdfsddf

End Sub

Private Sub Class_Terminate()

Set m_Factory = Nothing
Set m_Schema = Nothing
Set m_WSMLNode = Nothing

End Sub

Private Function ISoapTypeMapper_Iid() As String

ISoapTypeMapper_Iid = ""

End Function
Private Sub ISoapTypeMapper_Init(ByVal par_Factory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_Schema As MSXML2.IXMLDOMNode, ByVal par_WSMLNode As MSXML2.IXMLDOMNode, ByVal par_xsdType As MSSOAPLib30.enXSDType)

Set m_Factory = par_Factory
Set m_Schema = par_Schema
Set m_WSMLNode = par_WSMLNode
m_xsdType = par_xsdType

End Sub
Private Function ISoapTypeMapper_SchemaNode() As MSXML2.IXMLDOMNode

Set ISoapTypeMapper_SchemaNode = m_Schema

End Function
Private Function ISoapTypeMapper_VarType() As Long

ISoapTypeMapper_VarType = VBA.VbVarType.vbObject

End Function
Private Function ISoapTypeMapper_XsdType() As MSSOAPLib30.enXSDType

ISoapTypeMapper_XsdType = m_xsdType

End Function
Private Sub ISoapTypeMapper_Write(ByVal par_ISoapSerializer As MSSOAPLib30.ISoapSerializer, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long, par_var As Variant)

Dim serror As SoapError
Dim SoapTypeMapper As ISoapTypeMapper

Set serror = par_var
If Not par_ISoapSerializer Is Nothing Then
    par_ISoapSerializer.StartElement "faultcode"
    Set SoapTypeMapper = helper.GetTypeMapper(m_Factory, "enXSDstring", Nothing)
    If Not SoapTypeMapper Is Nothing Then
        SoapTypeMapper.Init m_Factory, Nothing, Nothing, enXSDstring
        SoapTypeMapper.Write par_ISoapSerializer, par_encoding, par_encodingMode, par_flags, serror.FaultCode
    End If
    par_ISoapSerializer.EndElement
    par_ISoapSerializer.StartElement "faultstring"
    If Not SoapTypeMapper Is Nothing Then
        SoapTypeMapper.Write par_ISoapSerializer, par_encoding, par_encodingMode, par_flags, serror.FaultString
    End If
    par_ISoapSerializer.EndElement
    par_ISoapSerializer.StartElement "detail"
    Set SoapTypeMapper = helper.GetTypeMapper(m_Factory, TypeName(serror.Detail), Nothing)
    If Not SoapTypeMapper Is Nothing Then
        SoapTypeMapper.Init m_Factory, Nothing, Nothing, enXSDstring
        SoapTypeMapper.Write par_ISoapSerializer, par_encoding, par_encodingMode, par_flags, serror.Detail
    End If
    par_ISoapSerializer.EndElement
    Set SoapTypeMapper = Nothing
End If
Set serror = Nothing

End Sub
Private Function ISoapTypeMapper_Read(ByVal par_soapreader As MSSOAPLib30.ISoapReader, ByVal par_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long) As Variant

Dim serror As New SoapError
Dim SoapTypeMapper As ISoapTypeMapper
Dim XMLDOMNode As MSXML2.IXMLDOMNode

If Not par_soapreader Is Nothing Then
    Set SoapTypeMapper = helper.GetTypeMapper(m_Factory, "enXSDstring", Nothing)
    If Not SoapTypeMapper Is Nothing Then
        SoapTypeMapper.Init m_Factory, Nothing, Nothing, enXSDstring
        Set XMLDOMNode = helper.GetNodeName(par_soapreader, par_Node, "faultcode")
        If Not XMLDOMNode Is Nothing Then serror.FaultCode = SoapTypeMapper.Read(par_soapreader, XMLDOMNode, par_encoding, par_encodingMode, par_flags)
        Set XMLDOMNode = Nothing
    End If
    If Not SoapTypeMapper Is Nothing Then
        Set XMLDOMNode = helper.GetNodeName(par_soapreader, par_Node, "faultstring")
        If Not XMLDOMNode Is Nothing Then serror.FaultString = SoapTypeMapper.Read(par_soapreader, XMLDOMNode, par_encoding, par_encodingMode, par_flags)
        Set XMLDOMNode = Nothing
    End If
    Set SoapTypeMapper = helper.GetTypeMapper(m_Factory, TypeName(serror), Nothing)
    If Not SoapTypeMapper Is Nothing Then
        SoapTypeMapper.Init m_Factory, Nothing, Nothing, enXSDstring
        Set XMLDOMNode = helper.GetNodeName(par_soapreader, par_Node, "detail")
        If Not XMLDOMNode Is Nothing Then Set serror.Detail = SoapTypeMapper.Read(par_soapreader, XMLDOMNode, par_encoding, par_encodingMode, par_flags)
        Set XMLDOMNode = Nothing
    End If
    Set SoapTypeMapper = Nothing
    Set ISoapTypeMapper_Read = serror
End If
Set serror = Nothing

End Function


