VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WSContainerInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IWSReferenciableInfo

Private current As IWSBaseInfo
Friend Property Set base(Value As IWSBaseInfo)

Set current = Value

End Property
Friend Property Get base() As IWSBaseInfo

Set base = current

End Property
Private Sub Class_Initialize()

Set current = Nothing

End Sub
Private Sub Class_Terminate()

Set current = Nothing

End Sub
Public Property Get Id() As String

If current Is Nothing Then Exit Property
Id = current.Value("id")

End Property
Public Property Get Connection() As WSConnection

If current Is Nothing Then Exit Property
Dim myConnection As New WSConnection
Set myConnection.base = QueryItem(current).Item("./WebServiceConnection")
Set Connection = myConnection
Set myConnection = Nothing

End Property
Public Property Get LocalTypes() As WSTypesInfo

If current Is Nothing Then Exit Property
Dim TypesInfo As New WSTypesInfo
Set TypesInfo.base = QueryItem(current).Item("./WebServiceTypes")
Set LocalTypes = TypesInfo
Set TypesInfo = Nothing

End Property
Public Property Get ContainerClass() As WSClassInfo

If current Is Nothing Then Exit Property
Dim ClassInfo As New WSClassInfo
Set ClassInfo.base = QueryItem(current).Item("./WebServiceContainer")
Set ContainerClass = ClassInfo
Set ClassInfo = Nothing

End Property
Private Function IWSReferenciableInfo_CreateReference(Optional Name As String = "") As IWSReferenciableInfo

Dim Reference As New WSContainerInfo

If Not current Is Nothing Then
    If Not current.Count("./..") = 0 Then
       Set Reference.base = Me.base.Create(Me.base.Name, Array("ref", "id"), Array(Me.WSReferenciableInfo.KeyReferenceName, Name))
       Set IWSReferenciableInfo_CreateReference = Reference
       Set Reference = Nothing
    End If
End If

End Function
Private Function IWSReferenciableInfo_isReference() As Boolean

If Not current Is Nothing Then IWSReferenciableInfo_isReference = Not current.Value("ref") = ""

End Function
Private Function IWSReferenciableInfo_Reference(index As Integer) As IWSReferenciableInfo

If Not current Is Nothing Then Set IWSReferenciableInfo_Reference = Clone(current.Item("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "'][" & index + 1 & "]"))

End Function
Private Function IWSReferenciableInfo_Original() As IWSReferenciableInfo

Set IWSReferenciableInfo_Original = Clone(QueryItem(current))

End Function
Private Function IWSReferenciableInfo_KeyReferenceName() As String

IWSReferenciableInfo_KeyReferenceName = Me.Id

End Function
Private Function IWSReferenciableInfo_ReferencesCount() As Integer

If Not current Is Nothing Then IWSReferenciableInfo_ReferencesCount = current.Count("//*[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "']")

End Function
Public Function WSReferenciableInfo() As IWSReferenciableInfo

Set WSReferenciableInfo = Me

End Function

Private Function Clone(base As IWSBaseInfo) As IWSReferenciableInfo

Dim a As New WSContainerInfo

Set a.base = base
Set Clone = a
Set a = Nothing

End Function

