VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WSTypesInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IWSReferenciableInfo

Public Enum OnErrorEnum
    ShowError
    Cancel
    Ignore
    Query
End Enum

Private current As IWSBaseInfo
Friend Property Set base(Value As IWSBaseInfo)

Set current = Value

End Property
Friend Property Get base() As IWSBaseInfo

Set base = current

End Property
Private Sub Class_Initialize()

Set current = Nothing

End Sub
Private Sub Class_Terminate()

Set current = Nothing

End Sub
Public Property Let OnError(Value As OnErrorEnum)

'QueryItem(current).value("OnError") = GetEnumName(value, "OnErrorEnum", "")

End Property
Public Property Get OnError() As OnErrorEnum

OnError = GetEnumValue(TLI.TLIApplication.InterfaceInfoFromObject(Me).parent, "OnErrorEnum", QueryItem(current).Value("OnError"), OnErrorEnum.Cancel)

End Property
Public Property Get TypeInfo(index As Variant) As WSTypeInfo

On Error Resume Next
If current Is Nothing Then Exit Property
Dim wTypeInfo As New WSTypeInfo
If TypeName(index) = "Integer" Then Set wTypeInfo.base = QueryItem(current).Item("./WebServiceType[" & index + 1 & "]")
If TypeName(index) = "String" Then Set wTypeInfo.base = QueryItem(current).Item("./WebServiceType[@id='" & index & "']")
If Not wTypeInfo.base Is Nothing Then Set TypeInfo = wTypeInfo
Set wTypeInfo = Nothing

End Property
Public Property Get Count() As Integer

If current Is Nothing Then Exit Property
Count = QueryItem(current).Count("./WebServiceType")

End Property
Public Function Add(TypeInfo As WSTypeInfo) As Boolean

If current Is Nothing Then Exit Function
Add = TypeInfo.base.Append(current)

End Function
Public Function Delete(index As Integer) As Boolean

If current Is Nothing Then Exit Function

End Function
Public Function AddCustomTypesToProxi(WebServiceProxi As WebServices.IWebServiceProxi) As Boolean

Dim i As Integer
Dim TypeInfo As WSTypeInfo

AddCustomTypesToProxi = True
For i = 0 To Me.Count - 1
    Set TypeInfo = Me.TypeInfo(i)
    If Not TypeInfo Is Nothing Then
       If Not WebServiceProxi.AddCustomType(TypeInfo.info.Id, TypeInfo.info.targetNameSpace, TypeInfo.Class.targetPROGID, TypeInfo.Class.iid) Then
          Select Case Me.OnError
                 Case OnErrorEnum.Cancel
                      AddCustomTypesToProxi = False
                      Exit Function
                 Case OnErrorEnum.Ignore
                 Case OnErrorEnum.ShowError
                      AddCustomTypesToProxi = False
                      MsgBox "Error al agregar el tipo :" & TypeInfo.info.Id & Chr(13) & TypeInfo.info.targetNameSpace, vbCritical, "Webservice"
                 Case OnErrorEnum.Query
                      If MsgBox("Error al agregar el tipo :" & TypeInfo.info.Id & Chr(13) & TypeInfo.info.targetNameSpace, vbOKCancel, "Webservice") = vbCancel Then
                          AddCustomTypesToProxi = False
                          Exit Function
                      End If
          End Select
       End If
    End If
Next
Set TypeInfo = Nothing

End Function
Private Function IWSReferenciableInfo_CreateReference(Optional Name As String = "") As IWSReferenciableInfo

Dim Reference As New WSContainerInfo

If Not current Is Nothing Then
    If Not current.Count("./..") = 0 Then
       Set Reference.base = Me.base.Create(Me.base.Name, Array("ref", "id"), Array(Me.WSReferenciableInfo.KeyReferenceName, Name))
       Set IWSReferenciableInfo_CreateReference = Reference
       Set Reference = Nothing
    End If
End If

End Function
Private Function IWSReferenciableInfo_isReference() As Boolean

If Not current Is Nothing Then IWSReferenciableInfo_isReference = Not current.Value("ref") = ""

End Function
Private Function IWSReferenciableInfo_Reference(index As Integer) As IWSReferenciableInfo

If Not current Is Nothing Then Set IWSReferenciableInfo_Reference = Clone(current.Item("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "'][" & index + 1 & "]"))

End Function
Private Function IWSReferenciableInfo_Original() As IWSReferenciableInfo

Set IWSReferenciableInfo_Original = Clone(QueryItem(current))

End Function
Private Function IWSReferenciableInfo_KeyReferenceName() As String

IWSReferenciableInfo_KeyReferenceName = QueryItem(current).Item("./..").Value("id")

End Function
Private Function IWSReferenciableInfo_ReferencesCount() As Integer

If Not current Is Nothing Then IWSReferenciableInfo_ReferencesCount = current.Count("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "']")

End Function
Public Function WSReferenciableInfo() As IWSReferenciableInfo

Set WSReferenciableInfo = Me

End Function
Private Function Clone(base As IWSBaseInfo) As IWSReferenciableInfo

Dim a As New WSTypesInfo

Set a.base = base
Set Clone = a
Set a = Nothing

End Function

