VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Area"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements MSSOAPLib30.ISoapTypeMapper

Private m_Factory As MSSOAPLib30.ISoapTypeMapperFactory
Private m_Schema As MSXML2.IXMLDOMNode
Private m_WSMLNode As MSXML2.IXMLDOMNode
Private m_xsdType As MSSOAPLib30.enXSDType

Private Sub Class_Initialize()

Set m_Factory = Nothing
Set m_Schema = Nothing
Set m_WSMLNode = Nothing

End Sub
Private Sub Class_Terminate()

Set m_Factory = Nothing
Set m_Schema = Nothing
Set m_WSMLNode = Nothing

End Sub

Private Function ISoapTypeMapper_Iid() As String

On Error Resume Next
ISoapTypeMapper_Iid = tli.TLIApplication.InterfaceInfoFromObject(Me).Guid

End Function
Private Sub ISoapTypeMapper_Init(ByVal par_Factory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_Schema As MSXML2.IXMLDOMNode, ByVal par_WSMLNode As MSXML2.IXMLDOMNode, ByVal par_xsdType As MSSOAPLib30.enXSDType)

Set m_Factory = par_Factory
Set m_Schema = par_Schema
Set m_WSMLNode = par_WSMLNode
m_xsdType = par_xsdType

End Sub
Private Function ISoapTypeMapper_SchemaNode() As MSXML2.IXMLDOMNode

Set ISoapTypeMapper_SchemaNode = m_Schema

End Function
Private Function ISoapTypeMapper_VarType() As Long

ISoapTypeMapper_VarType = VBA.VbVarType.vbObject

End Function
Private Function ISoapTypeMapper_XsdType() As MSSOAPLib30.enXSDType

ISoapTypeMapper_XsdType = m_xsdType

End Function
Private Sub ISoapTypeMapper_Write(ByVal par_ISoapSerializer As MSSOAPLib30.ISoapSerializer, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long, par_var As Variant)

Dim Area As PhModiClientVb6.Area
Dim SoapTypeMapper As ISoapTypeMapper

If TypeOf par_var Is PhModiClientVb6.Area Then
    Set Area = par_var
    If Not par_ISoapSerializer Is Nothing Then
        par_ISoapSerializer.StartElement "AreaInfoNames"
        Set SoapTypeMapper = SoapParser.GetTypeMapper(m_Factory, "enXSDarray", Nothing)
        If Not SoapTypeMapper Is Nothing Then
            SoapTypeMapper.Write par_ISoapSerializer, par_encoding, par_encodingMode, par_flags, Area.AreaInfoNames
        End If
        par_ISoapSerializer.EndElement
        par_ISoapSerializer.StartElement "AreaInfo"
        If Not SoapTypeMapper Is Nothing Then
            SoapTypeMapper.Write par_ISoapSerializer, par_encoding, par_encodingMode, par_flags, Area.AreaInfo
        End If
        par_ISoapSerializer.EndElement
        Set SoapTypeMapper = Nothing
    End If
End If
Set Area = Nothing

End Sub
Private Function ISoapTypeMapper_Read(ByVal par_soapreader As MSSOAPLib30.ISoapReader, ByVal par_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long) As Variant

Dim Area As New PhModiClientVb6.Area
Dim SoapTypeMapper As ISoapTypeMapper
Dim XMLDOMNode As MSXML2.IXMLDOMNode
Dim AreaInfoNames() As String
Dim AreaInfo() As String

If Not par_soapreader Is Nothing Then
    Set SoapTypeMapper = SoapParser.GetTypeMapper(m_Factory, "enXSDarray", Nothing)
    If Not SoapTypeMapper Is Nothing Then
        'SoapTypeMapper.Init m_Factory, Nothing, Nothing, enXSDarray
        Set XMLDOMNode = SoapParser.GetNodeName(par_soapreader, par_Node, "AreaInfoNames")
        If Not XMLDOMNode Is Nothing Then AreaInfoNames = SoapTypeMapper.Read(par_soapreader, XMLDOMNode, par_encoding, par_encodingMode, par_flags)
        Set XMLDOMNode = Nothing
    End If
    If Not SoapTypeMapper Is Nothing Then
        Set XMLDOMNode = SoapParser.GetNodeName(par_soapreader, par_Node, "AreaInfo")
        If Not XMLDOMNode Is Nothing Then AreaInfo = SoapTypeMapper.Read(par_soapreader, XMLDOMNode, par_encoding, par_encodingMode, par_flags)
        Set XMLDOMNode = Nothing
    End If
    Area.SetValues AreaInfoNames, AreaInfo
    Set ISoapTypeMapper_Read = Area
    Set SoapTypeMapper = Nothing
End If
Set Area = Nothing

End Function



