VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IPhModiApi"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum TypeElement
    Document
    schema
    template
End Enum
Public Enum EAreType
     Body
     Header
     footer
End Enum
Public Enum EPageSize
    A0 = 0
    A1 = 1
    A2 = 2
    A3 = 3
    A4 = 4
    A5 = 5
    B4 = 6
    B5 = 7
    Executive = 8
    Folio = 9
    Ledger = 10
    Legal = 11
    Letter = 12
    Quarto = 13
    Size10x14 = 14
    Tabloid = 15
End Enum
Public Enum ELANG
    CHINESE_SIMPLIFIED = 2052
    CHINESE_TRADITIONAL = 1028
    CZECH = 5
    DANISH = 6
    DUTCH = 19
    ENGLISH = 9
    FINNISH = 11
    FRENCH = 12
    GERMAN = 7
    GREEK = 8
    HUNGARIAN = 14
    ITALIAN = 16
    JAPANESE = 17
    KOREAN = 18
    NORWEGIAN = 20
    POLISH = 21
    PORTUGUESE = 22
    RUSSIAN = 25
    SPANISH = 10
    SWEDISH = 29
    SYSDEFAULT = 2048
    TURKISH = 31
End Enum
Public Function GetDocumentName(ByVal id As String) As String

End Function
Public Function ExistElement(ByVal ElementName As String, ByVal TypeElement As TypeElement) As Boolean

End Function
Public Function GetLastException() As String

End Function
Public Function IsAvailable() As Boolean

End Function
Public Function DropSchema(ByVal SchemaName As String) As Boolean

End Function
Public Function GetTemplatesNames() As String()

End Function
Public Function GetSchemasNames() As String()

End Function
Public Function GetElementsSchema(ByVal SchemaName As String) As String()

End Function
Public Function GetElementTemplate(ByVal templateName As String) As String

End Function
Public Function GetXSLTNames(ByVal SchemaName As String) As String()

End Function
Public Function DropXSLT(ByVal SchemaName As String, ByVal Operation As String) As Boolean

End Function
Public Function GetUrisSchema(ByVal SchemaName As String, ByVal ElementName As String, ByVal nomesFulles As Boolean) As String()

End Function
Public Function GetTemplateNameDocument(ByVal documentName As String) As String

End Function
Public Function DropTemplate(ByVal templateName As String) As Boolean

End Function
Public Function DropDocument(ByVal documentName As String) As Boolean

End Function
Public Function GetDocumentsNamesTemplates(ByVal templateName As String) As String()

End Function
Public Function FindDocuments() As String()

End Function
Public Function GetTemplatesSchema(ByVal SchemaName As String) As String()

End Function
Public Function GetDocumentsNamesStateBySchemaName(ByVal SchemaName As String, ByVal state As String) As String()

End Function
Public Function GetDocumentsNamesStateByTemplateNames(ByRef templateName() As String, ByVal state As String) As String()

End Function
Public Function GetDocumentNameState(ByVal documentName As String) As String

End Function
Public Function ChangeDocumentNameState(ByVal documentName As String, ByVal Newstate As String) As Boolean

End Function
Public Function ChangeDocumentNamePreviusState(ByVal documentName As String, ByVal OldState As String, ByVal Newstate As String) As Boolean

End Function
Public Function Hasdocuments(ByVal templateName As String) As Boolean

End Function
Public Function HasTemplates(ByVal SchemaName As String) As Boolean

End Function
Public Function PutXSLT(ByVal SchemaName As String, ByVal Operation As String, ByVal XSLT As DownloadFile) As Boolean

End Function
Public Function GetXSLT(ByVal SchemaName As String, ByVal Operation As String) As DownloadFile

End Function
Public Function GetSchema(ByVal SchemaName As String) As DownloadFile

End Function
Public Function GetDefauldImageTemplate(ByVal templateName As String) As DownloadFile

End Function
Public Function ParsingDocumentByComponentDesignators(ByVal Document As DocumentInfo, ByRef ComponentDesignators() As Uri) As ParsingOcrResult

End Function
Public Function ParsingDocumentByImage(ByVal Document As DocumentInfo, ByVal image As DownloadFile) As ParsingOcrResult

End Function
Public Function GetDocument(ByVal documentName As String) As ParsingOcrResult

End Function
Public Function PutDocument(ByVal Document As ParsingOcrResult) As Boolean

End Function
Public Function PutDocumentByComponentDesignators(ByVal Document As DocumentInfo, ByRef ComponentDesignators() As Uri) As Boolean

End Function

Public Function PutDocumentByImage(ByVal Document As DocumentInfo, ByVal image As DownloadFile) As Boolean

End Function
Public Function NewDocument(ByVal ConditionName As String, ByVal state As String, ByVal DocumentType As TypeElement, save As Boolean) As DocumentInfo

End Function
Public Function PutSchema(ByVal schema As DownloadFile) As Boolean

End Function
Public Function GetSchemaTemplate(ByVal templateName As String) As DownloadFile

End Function
Public Function GetTemplateInfo(ByVal templateName As String) As TemplateInfo

End Function
Public Function GetInitialStateTemplate(ByVal templateName As String) As String

End Function
Public Function GetPageSizeTemplate(ByVal templateName As String) As EPageSize

End Function
Public Function GetLanguageTemplate(ByVal templateName As String) As ELANG

End Function
Public Function GetSchemaNameTemplate(ByVal templateName As String) As String

End Function
Public Function PutTemplateByDownloadFile(ByVal templateName As String, ByVal template As DownloadFile, ByVal image As DownloadFile) As Boolean

End Function
Public Function PutTemplate(ByVal templateName As String, ByRef areas() As Area, ByVal image As DownloadFile, ByVal SchemaUri As String, ByVal ElementName As String, ByVal language As ELANG, ByVal InitialState As String, ByVal PageSize As EPageSize) As Boolean

End Function
Public Function GetAreasTemplate(ByVal templateName As String) As Area()

End Function
Public Function CreateAreaTemplate(ByRef areaInfo() As String, ByRef areaInfoNames() As String) As Area

End Function
Public Function GetDocumentValues(ByVal documentName As String, ByRef uris() As String) As Uri()

End Function

