VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PhModiApiProxi"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements PhModiClientVb6.IPhModiApi
Implements WebServices.IWebServiceContainer
Implements PhModiClientVb6.IApiArxiuOptic

Private Initialized As Boolean
Private Reflection As WebServices.IReflectionType
Private ServiceProxi As WebServices.IWebServiceProxi
Private SoapClient As MSSOAPLib30.SoapClient30

Private Function IPhModiApi_ChangeDocumentNamePreviusState(ByVal documentName As String, ByVal OldState As String, ByVal Newstate As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_ChangeDocumentNamePreviusState = SoapClient.ChangeDocumentNameStateSemafo(documentName, OldState, Newstate)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "ChangeDocumentNamePreviusState", Nothing, SoapClient

End Function
Private Function IPhModiApi_ChangeDocumentNameState(ByVal documentName As String, ByVal Newstate As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_ChangeDocumentNameState = SoapClient.ChangeDocumentNameState(documentName, Newstate)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "ChangeDocumentNameState", Nothing, SoapClient

End Function
Private Function IPhModiApi_CreateAreaTemplate(AreaInfo() As String, AreaInfoNames() As String) As PhModiClientVb6.Area

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_CreateAreaTemplate = Me.WebServiceProxi.EndInvoke(SoapClient.CreateAreaTemplate(AreaInfo, AreaInfoNames), ("CreateAreaTemplate"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "CreateAreaTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_DropDocument(ByVal documentName As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_DropDocument = SoapClient.DropDocument(documentName)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "DropDocument", Nothing, SoapClient

End Function
Private Function IPhModiApi_DropSchema(ByVal SchemaName As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_DropSchema = SoapClient.DropSchema(SchemaName)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "DropSchema", Nothing, SoapClient

End Function
Private Function IPhModiApi_DropTemplate(ByVal templateName As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_DropTemplate = SoapClient.DropTemplate(templateName)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "DropTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_DropXSLT(ByVal SchemaName As String, ByVal Operation As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_DropXSLT = SoapClient.DropXSLT(SchemaName, Operation)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "DropXSLT", Nothing, SoapClient

End Function
Private Function IPhModiApi_ExistElement(ByVal ElementName As String, ByVal TypeElement As PhModiClientVb6.TypeElement) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_ExistElement = SoapClient.ExistElement(ElementName, TypeElement)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "ExistElement", Nothing, SoapClient

End Function
Private Function IPhModiApi_FindDocuments() As String()

Dim ret As SoapParser.ReturnValue

On Error GoTo tractar_error
Class_Initialize
MsgBox " Funcio per implementar"
If Not HiHaErrorServer(ret) Then Exit Function

tractar_error:
If ret Is Nothing Then Set ret = New SoapParser.ReturnValue
On Error GoTo 0: ResolverErrorHandler "FindDocuments", ret.GetError, SoapClient
Set ret = Nothing

End Function
Private Function IPhModiApi_GetAreasTemplate(ByVal templateName As String) As PhModiClientVb6.Area()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetAreasTemplate = Me.WebServiceProxi.EndInvoke(SoapClient.GetAreasTemplate(templateName), ("GetAreasTemplate"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetAreasTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDefauldImageTemplate(ByVal templateName As String) As PhModiClientVb6.DownloadFile

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_GetDefauldImageTemplate = Me.WebServiceProxi.EndInvoke(SoapClient.GetDefauldImageTemplate(templateName), ("GetDefauldImageTemplate"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetDefauldImageTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDocument(ByVal documentName As String) As PhModiClientVb6.ParsingOcrResult

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_GetDocument = Me.WebServiceProxi.EndInvoke(SoapClient.GetDocument(documentName), ("GetDocument"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetDocument", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDocumentName(ByVal id As String) As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetDocumentName = SoapClient.GetDocumentName(id)
Exit Function

tractar_error:
ResolverErrorHandler "GetDocumentName", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDocumentNameState(ByVal documentName As String) As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetDocumentNameState = SoapClient.GetDocumentNameState(documentName)
Exit Function

tractar_error:
ResolverErrorHandler "GetDocumentNameState", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDocumentsNamesStateBySchemaName(ByVal SchemaName As String, ByVal state As String) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetDocumentsNamesStateBySchemaName = SoapClient.GetDocumentsNamesStateBySchemaName(SchemaName, state)
Exit Function

tractar_error:
ResolverErrorHandler "GetDocumentsNamesStateBySchemaName", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDocumentsNamesStateByTemplateNames(templateName() As String, ByVal state As String) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetDocumentsNamesStateByTemplateNames = SoapClient.GetDocumentsNamesStateByTemplateNames(templateName, state)
Exit Function

tractar_error:
ResolverErrorHandler "GetDocumentsNamesStateByTemplateNames", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetDocumentsNamesTemplates(ByVal templateName As String) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetDocumentsNamesTemplates = SoapClient.GetDocumentsNamesTemplates(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "GetDocumentsNamesTemplates", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetDocumentValues(ByVal documentName As String, uris() As String) As uri()

On Error GoTo tractar_error
Class_Initialize
'SoapClient.GetDocumentValues documentName, uris
'IPhModiApi_GetDocumentValues = Me.WebServiceProxi.Invoke("GetDocumentValues", documentName, uris)
IPhModiApi_GetDocumentValues = Me.WebServiceProxi.EndInvoke(SoapClient.GetDocumentValues(documentName, uris), "GetDocumentValues")
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetDocumentValues", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetElementsSchema(ByVal SchemaName As String) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetElementsSchema = SoapClient.GetElementsSchema(SchemaName)
Exit Function

tractar_error:
ResolverErrorHandler "GetElementsSchema", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetElementTemplate(ByVal templateName As String) As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetElementTemplate = SoapClient.GetElementTemplate(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "GetElementTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetInitialStateTemplate(ByVal templateName As String) As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetInitialStateTemplate = SoapClient.GetInitialStateTemplate(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "GetInitialStateTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetLanguageTemplate(ByVal templateName As String) As PhModiClientVb6.ELANG

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetLanguageTemplate = SoapClient.GetLanguageTemplate(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "GetLanguageTemplate", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetLastException() As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetLastException = SoapClient.GetLastException()
Exit Function

tractar_error:
ResolverErrorHandler "GetLastException", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetPageSizeTemplate(ByVal templateName As String) As PhModiClientVb6.EPageSize

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetPageSizeTemplate = SoapClient.GetPageSizeTemplate(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "GetPageSizeTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetSchema(ByVal SchemaName As String) As PhModiClientVb6.DownloadFile

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_GetSchema = Me.WebServiceProxi.EndInvoke(SoapClient.getSchema(SchemaName), ("GetSchema"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetSchema", Nothing, SoapClient

End Function
Private Function IPhModiApi_GetSchemaNameTemplate(ByVal templateName As String) As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetSchemaNameTemplate = SoapClient.GetSchemaNameTemplate(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "GetSchemaNameTemplate", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetSchemasNames() As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetSchemasNames = SoapClient.GetSchemasNames()
Exit Function

tractar_error:
ResolverErrorHandler "GetSchemasNames", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetSchemaTemplate(ByVal templateName As String) As PhModiClientVb6.DownloadFile

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_GetSchemaTemplate = Me.WebServiceProxi.EndInvoke(SoapClient.GetSchemaTemplate(templateName), ("GetSchemaTemplate"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetSchemaTemplate", Nothing, SoapClient

End Function


Private Function IPhModiApi_GetTemplateInfo(ByVal templateName As String) As PhModiClientVb6.TemplateInfo

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_GetTemplateInfo = Me.WebServiceProxi.EndInvoke(SoapClient.GetTemplateInfo(templateName), ("GetTemplateInfo"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetTemplateInfo", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetTemplateNameDocument(ByVal documentName As String) As String

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetTemplateNameDocument = SoapClient.GetTemplateNameDocument(documentName)
Exit Function

tractar_error:
ResolverErrorHandler "GetTemplateNameDocument", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetTemplatesNames() As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetTemplatesNames = SoapClient.GetTemplatesNames()
Exit Function

tractar_error:
ResolverErrorHandler "GetTemplatesNames", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetTemplatesSchema(ByVal SchemaName As String) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetTemplatesSchema = SoapClient.GetTemplatesSchema(SchemaName)
Exit Function

tractar_error:
ResolverErrorHandler "GetTemplatesSchema", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetUrisSchema(ByVal SchemaName As String, ByVal ElementName As String, ByVal nomesFulles As Boolean) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetUrisSchema = SoapClient.GetUrisSchema(SchemaName, ElementName, nomesFulles)
Exit Function

tractar_error:
ResolverErrorHandler "GetUrisSchema", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetXSLT(ByVal SchemaName As String, ByVal Operation As String) As PhModiClientVb6.DownloadFile

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_GetXSLT = Me.WebServiceProxi.EndInvoke(SoapClient.GetXSLT(SchemaName, Operation), ("GetXSLT"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "GetXSLT", Nothing, SoapClient

End Function

Private Function IPhModiApi_GetXSLTNames(ByVal SchemaName As String) As String()

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_GetXSLTNames = SoapClient.GetXSLTNames(SchemaName)
Exit Function

tractar_error:
ResolverErrorHandler "GetXSLTNames", Nothing, SoapClient

End Function

Private Function IPhModiApi_Hasdocuments(ByVal templateName As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_Hasdocuments = SoapClient.Hasdocuments(templateName)
Exit Function

tractar_error:
ResolverErrorHandler "Hasdocuments", Nothing, SoapClient

End Function

Private Function IPhModiApi_HasTemplates(ByVal SchemaName As String) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_HasTemplates = SoapClient.HasTemplates(SchemaName)
Exit Function

tractar_error:
ResolverErrorHandler "HasTemplates", Nothing, SoapClient

End Function


Private Function IPhModiApi_IsAvailable() As Boolean

On Error GoTo tractar_error

Class_Initialize
If Not SoapClient Is Nothing Then IPhModiApi_IsAvailable = SoapClient.IsAvailable()
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "IsAvailable", Nothing, SoapClient

End Function
Private Function IPhModiApi_NewDocument(ByVal ConditionName As String, ByVal state As String, ByVal DocumentType As TypeElement, save As Boolean) As PhModiClientVb6.DocumentInfo

On Error GoTo tractar_error
Class_Initialize
Set IPhModiApi_NewDocument = Me.WebServiceProxi.EndInvoke(SoapClient.NewDocument(ConditionName, state, DocumentType, save), ("NewDocument"))
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "NewDocument", Nothing, SoapClient

End Function
Private Function IPhModiApi_ParsingDocumentByComponentDesignators(ByVal Document As PhModiClientVb6.DocumentInfo, ComponentDesignators() As uri) As PhModiClientVb6.ParsingOcrResult

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_ParsingDocumentByComponentDesignators = Me.WebServiceProxi.Invoke("ParsingDocumentByComponentDesignators", Document, ComponentDesignators)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "ParsingDocumentByComponentDesignators", Nothing, SoapClient

End Function

Private Function IPhModiApi_ParsingDocumentByImage(ByVal Document As PhModiClientVb6.DocumentInfo, ByVal image As PhModiClientVb6.DownloadFile) As PhModiClientVb6.ParsingOcrResult

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_ParsingDocumentByImage = Me.WebServiceProxi.Invoke("ParsingDocumentByImage", Document, image)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "ParsingDocumentByImage", Nothing, SoapClient

End Function

Private Function IPhModiApi_PutDocument(ByVal Document As PhModiClientVb6.ParsingOcrResult) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutDocument = Me.WebServiceProxi.Invoke("PutDocument", Document)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutDocument", Nothing, SoapClient

End Function
Private Function IPhModiApi_PutDocumentByComponentDesignators(ByVal Document As PhModiClientVb6.DocumentInfo, ComponentDesignators() As uri) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutDocumentByComponentDesignators = Me.WebServiceProxi.Invoke("PutDocumentByComponentDesignators", Document, ComponentDesignators)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutDocumentByComponentDesignators", Nothing, SoapClient

End Function
Private Function IPhModiApi_PutDocumentByImage(ByVal Document As PhModiClientVb6.DocumentInfo, ByVal image As PhModiClientVb6.DownloadFile) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutDocumentByImage = Me.WebServiceProxi.Invoke("PutDocumentByImage", Document, image)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutDocumentByImage", Nothing, SoapClient

End Function
Private Function IPhModiApi_PutSchema(ByVal schema As PhModiClientVb6.DownloadFile) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutSchema = Me.WebServiceProxi.Invoke("PutSchema", schema)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutSchema", Nothing, SoapClient

End Function
Private Function IPhModiApi_PutTemplate(ByVal templateName As String, areas() As PhModiClientVb6.Area, ByVal image As PhModiClientVb6.DownloadFile, ByVal SchemaUri As String, ByVal ElementName As String, ByVal language As PhModiClientVb6.ELANG, ByVal InitialState As String, ByVal PageSize As PhModiClientVb6.EPageSize) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutTemplate = Me.WebServiceProxi.Invoke("PutTemplate", templateName, areas, image, SchemaUri, ElementName, language, InitialState, PageSize)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutTemplate", Nothing, SoapClient

End Function
Private Function IPhModiApi_PutTemplateByDownloadFile(ByVal templateName As String, ByVal template As PhModiClientVb6.DownloadFile, ByVal image As PhModiClientVb6.DownloadFile) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutTemplateByDownloadFile = Me.WebServiceProxi.Invoke("PutTemplateByDownloadFile", templateName, template, image)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutTemplateByDownloadFile", Nothing, SoapClient

End Function
Private Function IPhModiApi_PutXSLT(ByVal SchemaName As String, ByVal Operation As String, ByVal XSLT As PhModiClientVb6.DownloadFile) As Boolean

On Error GoTo tractar_error
Class_Initialize
IPhModiApi_PutXSLT = Me.WebServiceProxi.Invoke("PutXSLT", SchemaName, Operation, XSLT)
Exit Function

tractar_error:
On Error GoTo 0: ResolverErrorHandler "PutXSLT", Nothing, SoapClient

End Function
Private Sub Class_Initialize()

On Error GoTo tractar_error
If Not ServiceProxi Is Nothing Then
    If Not Me.WebServiceProxi.IsAvailable Then
        Class_Terminate
    Else
        If SoapClient Is Nothing Then
            Set SoapClient = New MSSOAPLib30.SoapClient30
            SoapClient.MSSoapInit Me.WebServiceProxi.WSDLFileName, Me.WebServiceProxi.ServiceName, Me.WebServiceProxi.PortToName, Me.WebServiceProxi.WSMLFileName
        End If
    End If
End If
Initialized = Not SoapClient Is Nothing
Exit Sub

tractar_error:
On Error GoTo 0: ResolverErrorHandler "Initialize", Nothing, SoapClient
Class_Terminate

End Sub
Private Sub Class_Terminate()

On Error GoTo tractar_error

IWebServiceContainer_Terminate
Set SoapClient = Nothing
Initialized = False
Exit Sub

tractar_error:
On Error GoTo 0: ResolverErrorHandler "Terminate", Nothing, SoapClient

End Sub
Public Function ReflectionType() As WebServices.IReflectionType

If Reflection Is Nothing Then Set Reflection = New WebServiceConfig.AbstractReflectionType
If Not Reflection Is Nothing Then Reflection.Initialize Me.PhModiApi
Set ReflectionType = Reflection

End Function
Public Function WebServiceContainer() As WebServices.IWebServiceContainer

Set WebServiceContainer = Me

End Function
Public Function WebServiceProxi() As WebServices.IWebServiceProxi

On Error Resume Next

If ServiceProxi Is Nothing Then Set ServiceProxi = New WebServiceConfig.AbstractWebService
Set WebServiceProxi = ServiceProxi

End Function
Public Function PhModiApi() As PhModiClientVb6.IPhModiApi

Set PhModiApi = Me

End Function
Private Function IWebServiceContainer_ReflectionType() As WebServices.IReflectionType

If Not Initialized Then Class_Initialize
Set IWebServiceContainer_ReflectionType = Me.ReflectionType

End Function

Private Sub IWebServiceContainer_Terminate()

If Not ServiceProxi Is Nothing Then Me.WebServiceProxi.Terminate
If Not Reflection Is Nothing Then Me.ReflectionType.Terminate
Set ServiceProxi = Nothing
Set Reflection = Nothing

End Sub

Private Function IWebServiceContainer_WebServiceProxi() As WebServices.IWebServiceProxi

If Not Initialized Then Class_Initialize
Set IWebServiceContainer_WebServiceProxi = Me.WebServiceProxi

End Function
