VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WSBaseInfoXml"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements IWSBaseInfo

Private current As MSXML2.IXMLDOMNode
Public Function DOM() As MSXML2.IXMLDOMNode

Set DOM = current

End Function
Public Sub Init(node As MSXML2.IXMLDOMNode)

Set current = node ', ".", True)

End Sub

Private Sub Class_Initialize()

Set current = Nothing

End Sub

Private Sub Class_Terminate()

Set current = Nothing

End Sub
Friend Function CreateBase(node As MSXML2.IXMLDOMNode) As IWSBaseInfo

Dim base As New WSBaseInfoXml

base.Init node
Set CreateBase = base
Set base = Nothing

End Function
Friend Function GetDom(base As IWSBaseInfo) As MSXML2.IXMLDOMNode

Dim mbase As WSBaseInfoXml

If TypeOf base Is WSBaseInfoXml And Not base Is Nothing Then
    Set mbase = base
    Set GetDom = mbase.DOM
End If

End Function
Private Function IWSBaseInfo_Append(parent As IWSBaseInfo) As Boolean

Dim parentNode As MSXML2.IXMLDOMNode

Set parentNode = GetDom(parent)
If Not parentNode Is Nothing And Not current Is Nothing Then
    If ownerDocument(parentNode) Is ownerDocument(current) Then
       parentNode.appendChild current
       IWSBaseInfo_Append = True
    End If
End If

End Function
Private Function IWSBaseInfo_Count(xpath As String) As Integer

IWSBaseInfo_Count = current.selectNodes(xpath).length

End Function

Private Function IWSBaseInfo_Name() As String

If Not current Is Nothing Then IWSBaseInfo_Name = current.baseName

End Function

Private Function IWSBaseInfo_UnAppend(parent As IWSBaseInfo) As Boolean

Dim i As Integer
Dim parentNode As MSXML2.IXMLDOMNode

Set parentNode = GetDom(parent)
If Not parentNode Is Nothing And Not current Is Nothing Then
    If parentNode Is current.parentNode Then
        parentNode.removeChild current
        IWSBaseInfo_UnAppend = current.parentNode Is Nothing
    End If
End If

End Function
Public Function WSBaseInfo() As IWSBaseInfo

Set WSBaseInfo = Me

End Function
Private Function IWSBaseInfo_ReferencesCount(KeyReference As String) As Integer

If Not Me Is Nothing Then IWSBaseInfo_ReferencesCount = Me.WSBaseInfo.Count("//" & current.baseName & "[@ref='" & KeyReference & "']")

End Function
Private Function IWSBaseInfo_Item(xpath As String) As IWSBaseInfo

Set IWSBaseInfo_Item = Me.CreateBase(current.selectSingleNode(xpath))

End Function
Private Function IWSBaseInfo_Create(ElementName As String, AttributeNames As Variant, AttributeValues As Variant) As IWSBaseInfo

Dim i As Integer
Dim XMLDOMElement As MSXML2.IXMLDOMElement

If Not ownerDocument(current) Is Nothing Then
    Set XMLDOMElement = ownerDocument(current).createElement(ElementName)
    If TeElements(AttributeNames) Then
        For i = LBound(AttributeNames) To UBound(AttributeNames)
            If Not GetElement(AttributeValues, i) = "" And Not GetElement(AttributeNames, i) = "" Then WSInfoHelper.SetAttribute XMLDOMElement, GetElement(AttributeNames, i), GetElement(AttributeValues, i), True
        Next
    End If
End If
Set IWSBaseInfo_Create = Me.CreateBase(XMLDOMElement)
Set XMLDOMElement = Nothing

End Function
Private Property Let IWSBaseInfo_Value(AttributeName As Variant, RHS As String)

WSInfoHelper.SetAttribute current, AttributeName, RHS, False

End Property

Private Property Get IWSBaseInfo_Value(AttributeName As Variant) As String

IWSBaseInfo_Value = WSInfoHelper.GetAttribute(current, AttributeName)

End Property

Private Function IWSBaseInfo_ValuesCount() As Integer

End Function
