VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WSConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IWSReferenciableInfo

Private current As IWSBaseInfo
Friend Property Set base(value As IWSBaseInfo)

Set current = value

End Property
Friend Property Get base() As IWSBaseInfo

Set base = current

End Property
Private Sub Class_Initialize()

Set current = Nothing

End Sub
Private Sub Class_Terminate()

Set current = Nothing

End Sub
Public Property Get wsdlfile() As String

If current Is Nothing Then Exit Property
wsdlfile = QueryItem(current).value("wsdlfile")

End Property
Public Property Let wsdlfile(value As String)

If current Is Nothing Then Exit Property
If Not current.value("ref") = "" Then Exit Property
current.value("wsdlfile") = value

End Property
Public Property Let Service(value As String)

If current Is Nothing Then Exit Property
If Not current.value("ref") = "" Then Exit Property
current.value("Service") = value

End Property
Public Property Get Service() As String

If current Is Nothing Then Exit Property
Service = QueryItem(current).value("Service")

End Property
Public Property Get Port() As String

If current Is Nothing Then Exit Property
Port = QueryItem(current).value("Port")

End Property
Public Property Let Port(value As String)

If current Is Nothing Then Exit Property
If Not current.value("ref") = "" Then Exit Property
current.value("Port") = value

End Property
Public Property Get wsmlfile() As String

If current Is Nothing Then Exit Property
wsmlfile = QueryItem(current).value("wsmlfile")

End Property
Public Property Let wsmlfile(value As String)

If current Is Nothing Then Exit Property
If Not current.value("ref") = "" Then Exit Property
current.value("wsmlfile") = value

End Property
Private Function IWSReferenciableInfo_CreateReference(Optional Name As String = "") As IWSReferenciableInfo

Dim Reference As New WSContainerInfo

If Not current Is Nothing Then
    If Not current.Count("./..") = 0 Then
       Set Reference.base = Me.base.Create(Me.base.Name, Array("ref", "id"), Array(Me.WSReferenciableInfo.KeyReferenceName, Name))
       Set IWSReferenciableInfo_CreateReference = Reference
       Set Reference = Nothing
    End If
End If

End Function
Private Function IWSReferenciableInfo_isReference() As Boolean

If Not current Is Nothing Then IWSReferenciableInfo_isReference = Not current.value("ref") = ""

End Function
Private Function IWSReferenciableInfo_Reference(index As Integer) As IWSReferenciableInfo

If Not current Is Nothing Then Set IWSReferenciableInfo_Reference = Clone(current.Item("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "'][" & index + 1 & "]"))

End Function
Private Function IWSReferenciableInfo_Original() As IWSReferenciableInfo

Set IWSReferenciableInfo_Original = Clone(QueryItem(current))

End Function
Private Function IWSReferenciableInfo_KeyReferenceName() As String

IWSReferenciableInfo_KeyReferenceName = QueryItem(current).Item("./..").value("id")

End Function
Private Function IWSReferenciableInfo_ReferencesCount() As Integer

If Not current Is Nothing Then IWSReferenciableInfo_ReferencesCount = current.Count("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "']")

End Function
Public Function WSReferenciableInfo() As IWSReferenciableInfo

Set WSReferenciableInfo = Me

End Function
Private Function Clone(base As IWSBaseInfo) As IWSReferenciableInfo

Dim a As New WSConnection

Set a.base = base
Set Clone = a
Set a = Nothing

End Function


