VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WSTypeInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IWSReferenciableInfo

Private current As IWSBaseInfo
Friend Property Set base(value As IWSBaseInfo)

Set current = value

End Property
Friend Property Get base() As IWSBaseInfo

Set base = current

End Property
Private Sub Class_Initialize()

Set current = Nothing

End Sub
Private Sub Class_Terminate()

Set current = Nothing

End Sub

Public Property Get Class() As WSClassInfo

If current Is Nothing Then Exit Property
Dim ClassInfo As New WSClassInfo
Set ClassInfo.base = current
Set Class = ClassInfo
Set ClassInfo = Nothing

End Property
Public Property Get info() As WSNameInfo

If current Is Nothing Then Exit Property
Dim NameInfo As New WSNameInfo
Set NameInfo.base = current
Set info = NameInfo
Set NameInfo = Nothing

End Property
Private Function IWSReferenciableInfo_CreateReference(Optional Name As String = "") As IWSReferenciableInfo

Dim Reference As New WSContainerInfo

If Not current Is Nothing Then
    If Not current.Count("./..") = 0 Then
       Set Reference.base = Me.base.Create(Me.base.Name, Array("ref", "id"), Array(Me.WSReferenciableInfo.KeyReferenceName, Name))
       Set IWSReferenciableInfo_CreateReference = Reference
       Set Reference = Nothing
    End If
End If

End Function
Private Function IWSReferenciableInfo_isReference() As Boolean

If Not current Is Nothing Then IWSReferenciableInfo_isReference = Not current.value("ref") = ""

End Function
Private Function IWSReferenciableInfo_Reference(index As Integer) As IWSReferenciableInfo

If Not current Is Nothing Then Set IWSReferenciableInfo_Reference = Clone(current.Item("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "'][" & index + 1 & "]"))

End Function
Private Function IWSReferenciableInfo_Original() As IWSReferenciableInfo

Set IWSReferenciableInfo_Original = QueryItem(current)

End Function
Private Function IWSReferenciableInfo_KeyReferenceName() As String

IWSReferenciableInfo_KeyReferenceName = QueryItem(current).Item("./../..").value("id")

End Function
Private Function IWSReferenciableInfo_ReferencesCount() As Integer

If Not current Is Nothing Then IWSReferenciableInfo_ReferencesCount = current.Count("//" & current.Name & "[@ref='" & Me.WSReferenciableInfo.KeyReferenceName & "']")

End Function
Public Function WSReferenciableInfo() As IWSReferenciableInfo

Set WSReferenciableInfo = Me

End Function
Private Function Clone(base As IWSBaseInfo) As IWSReferenciableInfo

Dim a As New WSTypeInfo

Set a.base = base
Set Clone = a
Set a = Nothing

End Function


