VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WebServiceFactory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements WebServices.IWebServiceFactory

Private FactoryInfo As WSFactoryInfo
Private Sub Class_Initialize()

Set FactoryInfo = Nothing

End Sub
Private Sub Class_Terminate()

Set FactoryInfo = Nothing

End Sub
Private Function IWebServiceFactory_ExistWebServiceContainer(WebService As String) As Boolean

If Me.WebServiceFactory.IsAvailable Then IWebServiceFactory_ExistWebServiceContainer = FactoryInfo.ExistContainerInfo(WebService)

End Function

Private Function IWebServiceFactory_WebServiceContainer(WebService As String) As IWebServiceContainer

If Me.WebServiceFactory.IsAvailable Then Set IWebServiceFactory_WebServiceContainer = FactoryInfo.WebServiceContainer(WebService)

End Function
Private Sub IWebServiceFactory_Initialize(WebServiceProxiInfo As Variant)

Dim DOM As MSXML2.IXMLDOMDocument

On Error GoTo t
Select Case TypeName(WebServiceProxiInfo)
       Case "String"
            Set DOM = New MSXML2.DOMDocument40
            If Not DOM.Load(WebServiceProxiInfo) Then Set DOM = Nothing
       Case "DOMDocument40"
            Set DOM = WebServiceProxiInfo
       'case other
End Select
Set FactoryInfo = New WSFactoryInfo
FactoryInfo.Load DOM
t:
Set DOM = Nothing

End Sub
Private Function IWebServiceFactory_IsAvailable() As Boolean
 IWebServiceFactory_IsAvailable = Not FactoryInfo Is Nothing
End Function
Private Sub IWebServiceFactory_Terminate()

Class_Terminate

End Sub
Public Function WebServiceFactory() As WebServices.IWebServiceFactory

Set WebServiceFactory = Me

End Function
Public Function WebServiceFactoryInfo() As WSFactoryInfo

Set WebServiceFactoryInfo = FactoryInfo

End Function
Public Function SaveAs(filename As String) As Boolean

Dim base As WSBaseInfoXml

On Error GoTo t
If Not FactoryInfo Is Nothing Then
    If Not FactoryInfo.base Is Nothing Then
        Set base = FactoryInfo.base
        If Not ownerDocument(base.DOM) Is Nothing Then
            ownerDocument(base.DOM).save filename
            SaveAs = True
        End If
        Set base = Nothing
    End If
End If
t:

End Function
